#include "B4RDefines.h"

namespace B4R {
	void B4RDusk2Dawn::Initialize(float Longitude, float Latitude, float Timezone) {
		d2d =  new (backend) Dusk2Dawn(Longitude,Latitude,Timezone);
	}
	int B4RDusk2Dawn::Sunrise(int Year, int Month, int Day, bool DayLightSavingTime) {
		return d2d->sunrise(Year,Month,Day,DayLightSavingTime);
	}

	int B4RDusk2Dawn::Sunset(int Year, int Month, int Day, bool DayLightSavingTime) {
		return d2d->sunset(Year,Month,Day,DayLightSavingTime);
	}

	int B4RDusk2Dawn::GetHour(int MinutesSinceMidnight) {
		return MinutesSinceMidnight / 60;
	}

	int B4RDusk2Dawn::GetMinute(int MinutesSinceMidnight) {
		float floatHour   = MinutesSinceMidnight / 60.0;
		return (int) 60.0 * (floatHour - floor(floatHour));
	}

	int B4RDusk2Dawn::GetSunriseHour(int Year, int Month, int Day, bool DayLightSavingTime) {
		float MinutesSinceMidnight = d2d->sunrise(Year,Month,Day,DayLightSavingTime);
		return (int) MinutesSinceMidnight / 60.0;
	}

	int B4RDusk2Dawn::GetSunriseMinute(int Year, int Month, int Day, bool DayLightSavingTime) {
		float MinutesSinceMidnight = d2d->sunrise(Year,Month,Day,DayLightSavingTime);
		float floatHour   = MinutesSinceMidnight / 60.0;
		return (int) 60.0 * (floatHour - floor(floatHour));
	}

	int B4RDusk2Dawn::GetSunsetHour(int Year, int Month, int Day, bool DayLightSavingTime) {
		float MinutesSinceMidnight = d2d->sunset(Year,Month,Day,DayLightSavingTime);
		return (int) MinutesSinceMidnight / 60.0;
	}

	int B4RDusk2Dawn::GetSunsetMinute(int Year, int Month, int Day, bool DayLightSavingTime) {
		float MinutesSinceMidnight = d2d->sunset(Year,Month,Day,DayLightSavingTime);
		float floatHour   = MinutesSinceMidnight / 60.0;
		return (int) 60.0 * (floatHour - floor(floatHour));
	}

	bool B4RDusk2Dawn::IsDaylightSavingTime(int DayOfWeek, int Month, int Day) {
		//	January, February & December are out
		if (Month < 3 || Month > 11)
		{
			return false;
		}
		//	April to October are in
		if (Month > 3 && Month < 11)
		{
			return true;
		}
		//	In March, we are DST if Previous Sunday on or after 8th
		Int PreviousSunday = Day - DayOfWeek;
		if (Month == 3)
		{
			if (PreviousSunday >= 7)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		//	In November we must be berfore the 1st sunday to be DST
		//	That means previuous sunday must be before the first the 1st NOT Possible
		if (PreviousSunday <= 0)
		{
			return true;
		}
		return false;
		}

}